/****************************************************************************
 * Obiblob functions                                                       *
 ****************************************************************************/

/**
 * @file obiblob_indexer.c
 * @author Celine Mercier
 * @date April 12th 2016
 * @brief Functions handling the indexing and retrieval of blob structures.
 */


#include <stdlib.h>
#include <stdio.h>

#include "obiblob_indexer.h"
#include "obidms.h"
#include "obiavl.h"


#define DEBUG_LEVEL 0	// TODO has to be defined somewhere else (cython compil flag?)


inline int obi_indexer_exists(OBIDMS_p dms, const char* name);

inline Obi_indexer_p obi_indexer(OBIDMS_p dms, const char* name);

inline Obi_indexer_p obi_create_indexer(OBIDMS_p dms, const char* name);

inline Obi_indexer_p obi_open_indexer(OBIDMS_p dms, const char* name);

inline int obi_close_indexer(Obi_indexer_p indexer);

inline index_t obi_indexer_add(Obi_indexer_p indexer, Obi_blob_p value);

inline Obi_blob_p obi_indexer_get(Obi_indexer_p indexer, index_t idx);

